//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#include "stdafx.h"
#include "emule.h"
#include "NetF.h"
#include "PPgNetF.h"
#include "Inputbox.h"
#include "OtherFunctions.h"
#include "Preferences.h"
#include "HelpIDs.h"

// CPPgNetF dialog

IMPLEMENT_DYNAMIC(CPPgNetF, CPropertyPage)
CPPgNetF::CPPgNetF()
	: CPropertyPage(CPPgNetF::IDD)
{
}

CPPgNetF::~CPPgNetF()
{
}

void CPPgNetF::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CPPgNetF, CPropertyPage)
	ON_BN_CLICKED(IDC_NETF_SFP_NONE, OnSettingsChange)
	ON_BN_CLICKED(IDC_NETF_SFP_NONLINEAR, OnSettingsChange)
	ON_BN_CLICKED(IDC_NETF_SFP_FULL, OnSettingsChange)
	ON_BN_CLICKED(IDC_NETF_MAX_SLOTS_ENABLE, OnSettingsChange)
	ON_BN_CLICKED(IDC_NETF_MIN_DATARATE_ENABLE, OnSettingsChange)
	ON_BN_CLICKED(IDC_NETF_PAYBACK_ENABLE, OnSettingsChange)
	ON_BN_CLICKED(IDC_NETF_FASTQUEUE_ENABLE, OnSettingsChange)
	ON_BN_CLICKED(IDC_NETF_FRESHMANCREDITS_ENABLE, OnSettingsChange)
	ON_BN_CLICKED(IDC_NETF_DOWNLOADHIDDEN_ENABLE, OnSettingsChange)
	ON_BN_CLICKED(IDC_NETF_RARECREDITS_ENABLE, OnSettingsChange)
	ON_EN_CHANGE(IDC_NETF_MAX_SLOTS, OnSettingsChange)
	ON_EN_CHANGE(IDC_NETF_MIN_DATARATE, OnSettingsChange)
	ON_WM_HSCROLL()
	ON_CBN_SELCHANGE(IDC_NETF_TASK_PRIORITY, OnSettingsChange)
END_MESSAGE_MAP()

BOOL CPPgNetF::OnInitDialog()
{
	CPropertyPage::OnInitDialog();
	InitWindowStyles(this);

	LoadSettings();
	Localize();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CPPgNetF::LoadSettings(void)
{
	CheckRadioButton(IDC_NETF_SFP_NONE, IDC_NETF_SFP_FULL, IDC_NETF_SFP_NONE + theNetF.m_iSmallFilePush);
	if (theNetF.m_bMaxUpSlotsEnabled) 
		CheckDlgButton(IDC_NETF_MAX_SLOTS_ENABLE, BST_CHECKED);
	if (theNetF.m_bMinUpDatarateEnabled) 
		CheckDlgButton(IDC_NETF_MIN_DATARATE_ENABLE, BST_CHECKED);

	CString strBuffer;
	strBuffer.Format(_T("%d"), theNetF.m_iMaxUpSlots);
	GetDlgItem(IDC_NETF_MAX_SLOTS)->SetWindowText(strBuffer);
	strBuffer.Format(_T("%d"), theNetF.m_iMinUpDatarate / 1024);
	GetDlgItem(IDC_NETF_MIN_DATARATE)->SetWindowText(strBuffer);
	GetDlgItem(IDC_NETF_MAX_SLOTS)->EnableWindow(theNetF.m_bMaxUpSlotsEnabled);
	GetDlgItem(IDC_NETF_MIN_DATARATE)->EnableWindow(theNetF.m_bMinUpDatarateEnabled);
	((CSliderCtrl*) GetDlgItem(IDC_NETF_SLOT_INTERVAL))->SetRange(0,10);
	((CSliderCtrl*) GetDlgItem(IDC_NETF_SLOT_INTERVAL))->SetPos(theNetF.m_iUpSlotInterval);
	strBuffer.Format(_T("%d seconds"), ((CSliderCtrl*) GetDlgItem(IDC_NETF_SLOT_INTERVAL))->GetPos());
	GetDlgItem(IDC_NETF_SLOT_INTERVAL_TEXT)->SetWindowText(strBuffer);

	((CComboBox*)GetDlgItem(IDC_NETF_TASK_PRIORITY))->SetCurSel(theNetF.m_iTaskPriority);

	if (theNetF.m_bPaybackQueue) 
		CheckDlgButton(IDC_NETF_PAYBACK_ENABLE, BST_CHECKED);
	if (theNetF.m_bFastQueueRotation) 
		CheckDlgButton(IDC_NETF_FASTQUEUE_ENABLE, BST_CHECKED);
	if (theNetF.m_bFreshmanCredits) 
		CheckDlgButton(IDC_NETF_FRESHMANCREDITS_ENABLE, BST_CHECKED);
	if (theNetF.m_bDownloadHidden) 
		CheckDlgButton(IDC_NETF_DOWNLOADHIDDEN_ENABLE, BST_CHECKED);
	if (theNetF.m_bRarePartCredits) 
		CheckDlgButton(IDC_NETF_RARECREDITS_ENABLE, BST_CHECKED);
}

BOOL CPPgNetF::OnApply(void)
{
	TCHAR buffer[100];

	if(IsDlgButtonChecked(IDC_NETF_SFP_NONE))
		theNetF.m_iSmallFilePush = SFP_None;
	else if(IsDlgButtonChecked(IDC_NETF_SFP_NONLINEAR))
		theNetF.m_iSmallFilePush = SFP_Nonlinear;
	else
		theNetF.m_iSmallFilePush = SFP_Full;

	theNetF.m_bMaxUpSlotsEnabled = IsDlgButtonChecked(IDC_NETF_MAX_SLOTS_ENABLE);
	theNetF.m_bMinUpDatarateEnabled = IsDlgButtonChecked(IDC_NETF_MIN_DATARATE_ENABLE);
	if(GetDlgItem(IDC_NETF_MAX_SLOTS)->GetWindowTextLength())
	{
		GetDlgItem(IDC_NETF_MAX_SLOTS)->GetWindowText(buffer,20);
		theNetF.m_iMaxUpSlots = _tstoi(buffer);
	}
	if(GetDlgItem(IDC_NETF_MIN_DATARATE)->GetWindowTextLength())
	{
		GetDlgItem(IDC_NETF_MIN_DATARATE)->GetWindowText(buffer,20);
		theNetF.m_iMinUpDatarate = _tstoi(buffer) * 1024;
	}
	theNetF.m_iUpSlotInterval = ((CSliderCtrl*) GetDlgItem(IDC_NETF_SLOT_INTERVAL))->GetPos();

	theNetF.m_iTaskPriority = (ETaskPriority) ((CComboBox*)GetDlgItem(IDC_NETF_TASK_PRIORITY))->GetCurSel();

	theNetF.m_bPaybackQueue = IsDlgButtonChecked(IDC_NETF_PAYBACK_ENABLE);
	theNetF.m_bFastQueueRotation = IsDlgButtonChecked(IDC_NETF_FASTQUEUE_ENABLE);
	theNetF.m_bFreshmanCredits = IsDlgButtonChecked(IDC_NETF_FRESHMANCREDITS_ENABLE);
	theNetF.m_bDownloadHidden = IsDlgButtonChecked(IDC_NETF_DOWNLOADHIDDEN_ENABLE);
	theNetF.m_bRarePartCredits = IsDlgButtonChecked(IDC_NETF_RARECREDITS_ENABLE);
	
	LoadSettings();

	theNetF.UpdateTaskPriority();
	SetModified(FALSE);
	return CPropertyPage::OnApply();
}

void CPPgNetF::Localize(void)
{
	if(m_hWnd)
	{
	}
}

void CPPgNetF::OnHelp()
{
	//theApp.ShowHelp(eMule_FAQ_Preferences_Files);
}

BOOL CPPgNetF::OnCommand(WPARAM wParam, LPARAM lParam)
{
	if (wParam == ID_HELP)
	{
		OnHelp();
		return TRUE;
	}
	return __super::OnCommand(wParam, lParam);
}

BOOL CPPgNetF::OnHelpInfo(HELPINFO* pHelpInfo)
{
	OnHelp();
	return TRUE;
}

void CPPgNetF::OnSettingsChange() {
	SetModified();
	GetDlgItem(IDC_NETF_MAX_SLOTS)->EnableWindow(IsDlgButtonChecked(IDC_NETF_MAX_SLOTS_ENABLE));
	GetDlgItem(IDC_NETF_MIN_DATARATE)->EnableWindow(IsDlgButtonChecked(IDC_NETF_MIN_DATARATE_ENABLE));
}

void CPPgNetF::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	SetModified(TRUE);

	if( pScrollBar == (CScrollBar*)GetDlgItem(IDC_NETF_SLOT_INTERVAL))
	{
		CString strBuffer;
		strBuffer.Format(_T("%d seconds"), ((CSliderCtrl*) GetDlgItem(IDC_NETF_SLOT_INTERVAL))->GetPos());
		GetDlgItem(IDC_NETF_SLOT_INTERVAL_TEXT)->SetWindowText(strBuffer);
	}

	CPropertyPage::OnHScroll(nSBCode, nPos, pScrollBar);
}
